---
gitea: none
include_toc: true
---

## Older patch notes/version

Select different tags.

## TLDR Changelog

- Replaced the old standalone Docker/NFS server for a Proxmox/NFS instance. 

- Added 2 VMs as worker nodes to the cluster, they will be used/are intended for x64 bit images.

- One of the new added worker VMs receives a GPU through Proxmox PCI pass through.

- Some services might have been removed or added.

# Devices

## List of current devices:

### Standalone

```yaml
Gateway: 192.168.1.1
Proxmox/NFS: somwhere.
```

### Kluster

> Kubernetes Cluster

- Pi 4 with 4GB running as a Master. (Masterk/Pi4)

- A pair of Orange PI 5, so far all of them are the 8GB of RAM version. (Slave01-2)

- Proxmox VMs, both with 3 CPU cores and 8GB of RAM (Slave03-4)

- `Slave04` contains a GPU through Proxmox CPU pass through.

```yaml
Masterk: 192.168.1.9
Slave01: 192.168.1.10
Slave02: 192.168.1.11
Slave03: 192.168.1.12
Slave04: 192.168.1.13
```

```yaml
Node                 Available(GPUs)  Used(GPUs)
pi4.filter.home      0                0
slave01.filter.home  0                0
slave02.filter.home  0                0
slave03.filter.home  0                0
slave04.filter.home  1                0
```

## Which services I'm hosting

### Home Network

- CoreDNS
- DHCPd

### Discord Bots

- https://gitea.filterhome.xyz/ofilter/Steam_Invite_Discord (both Master and Dev branches)
- Shlink + ShlinkUI (deployed as it has functionality with the Steam Discord Bot from above)

### Public DNS

- Godaddy
- Duckdns

### CRDs

- Cert Manager
- Istio
- Nvidia Gpu Operator
- NFS Volume Provisioner
- MetalLB
 
### Observability

- Grafana
- Prometheus
- Kiali
- Jaeger

### CI/CD

- Jenkins master + dynamic agent(s)
- Docker Registry
- Skaffold (Client/User side, not running on the Kubernetes cluster, yet relies on it to create multiarch docker images)

### Git servers

- Gitea

### Media related

- Tube
- Fireshare
- Filebrowser
- Jellyfin
- qBitTorrent

## Downsides of my current setup

- Only 1 Kubernetes master node, therefore no full High Availability
- Only 1 NFS server / no HA NFS server, therefore if the NFS server is down most of the services on the Kubernetes cluster will also be down as they depend on such NFS


